<template>
  <div class="h-100">
    <div class="card-element py-2 px-3 rounded shadow h-100"
          :style="style"
          @touchstart="touchStart"
          @mousedown="touchStart"
          @touchmove="touchMove"
          @mousemove="touchMove"
          @touchend="touchEnd"
          @mouseup="touchEnd"
          :is-moving="isMoving"
          :type="card.type">
      <div class="center-container text-center message" :writable="card.writable">
        {{message}}
      </div>

      <div v-if="card.writable" class="w-100 flex-grow-1">
        <textarea class="precision-input pt-2" cols="5" placeholder="Tu peux préciser ta carte ici" />
      </div>

      <div v-if="card.plannable" class="w-100 flex-grow-1 text-center pb-2">
        <input type="date" value="02/01/2020" />
      </div>

      <button class="delete btn btn-outline-warning" v-if="!card.type">
        ✖ suprimmer
      </button>
    </div>
  </div>
</template>

<script>
export default {
  name: 'card',
  props: ['message', 'button', 'card'],
  data () {
    return {
      maxMoveX: 75,
      maxMoveY: 50,
      activationRatio: 0.75,
      startPosition: { x: 0, y: 0 },
      isMoving: false,
      currentPosition: { x: 0, y: 0 },
      currentSide: null
    }
  },
  computed: {
    style () {
      return {
        transform: `translate(${this.movement.x}px, ${this.movement.y}px) rotate(${this.rotation}deg)`
      }
    },
    rotation () {
      return (this.currentPosition.x / this.maxMoveX) * 5
    },
    movement () {
      const movement = this.currentPosition
      movement.y = this.cropValue(movement.y, this.maxMoveY)
      const reduceX = 1 - (movement.y < 0 ? 0 : movement.y / this.maxMoveY)
      movement.x = this.cropValue(movement.x, this.maxMoveX * reduceX)
      return movement
    }
  },
  methods: {
    touchStart (event) {
      this.startPosition = this.positionOfEvent(event)
      this.isMoving = true
    },
    touchMove (event) {
      if (this.isMoving) {
        const eventPosition = this.positionOfEvent(event)
        this.currentPosition = {
          x: eventPosition.x - this.startPosition.x,
          y: eventPosition.y - this.startPosition.y
        }
        this.setSide(this.currentPosition)
        this.sendPosition()
      }
    },
    touchEnd (event) {
      this.isMoving = false
      this.choose()
      if (!this.currentSide) {
        this.currentPosition = { x: 0, y: 0 }
        this.setSide(this.currentPosition)
        this.sendPosition()
      }
    },
    positionOfEvent (event) {
      if (event.type.includes('mouse')) {
        return { x: event.screenX, y: event.screenY }
      } else {
        return { x: event.touches[0].screenX, y: event.touches[0].screenY }
      }
    },
    setSide (position) {
      if (position.y > this.maxMoveY * this.activationRatio) {
        this.currentSide = 'bottom'
      } else if (position.x > this.maxMoveX * this.activationRatio) {
        this.currentSide = 'right'
      } else if (position.x < -this.maxMoveX * this.activationRatio) {
        this.currentSide = 'left'
      } else {
        this.currentSide = null
      }
    },
    sendPosition () {
      this.$emit('onSide', this.currentSide)
    },
    cropValue (value, max) {
      return Math.abs(value) > max ? Math.sign(value) * max : value
    },
    choose (side) {
      this.$emit('choose')
    }
  }
}
</script>

<style scoped lang="scss">
.card-element {
  color: var(--brain_secondary);
  background-color: white;
  display: flex;
  flex-direction: column;
  align-items: center;
  justify-content: center;
  user-select: none;
  transition: transform 500ms ease-in-out;
  max-height: var(--card_height);
  height: var(--card_height);
  min-height: var(--card_height);

  &[is-moving] {
    transition: unset;
  }

  &[type="advice"] {
    background-color: var(--brain_secondary);
    color: white;
  }
}

.message {
  font-size: 1.5em;

  &[writable] {
    font-size: 1.2em;
  }
}

.delete {
  color: #ffc107;
  font-size: 10px;
}

.precision-input {
  width: 100%;
  border: none;
  border-top: 1px solid black;
}
</style>
